#include <iostream>
using namespace std;

#define MAX 50

struct Aluno {
    int matricula;
    float nota;
};

int enfileirar(Aluno v[], int &fim, int &num, Aluno valor);
int desenfileirar(Aluno v[], int &ini, int fim, int &num, Aluno &valor);

int main(void) {
    // Declara e inicializa fila
    Aluno fila[MAX];
    int ifila = 0;
    int ffila = -1;
    int nfila = 0;

   // Varivel para armazenar dados digitados
    Aluno dado;
    int n;

    cout << "Quantos alunos deseja enfileirar? ";
    cin >> n;

    while (n>0) {
        cout << "Digite a matricula do aluno: ";
        cin >> dado.matricula;
        cout << "Digite a nota do aluno: ";
        cin >> dado.nota;
        enfileirar(fila, ffila, nfila, dado);
        n--;
    }

    // Agora mostra o reultado...
    while (desenfileirar(fila, ifila, ffila, nfila, dado) == 0) {
        cout << "Matr: " << dado.matricula << endl;
        cout << "Nota: " << dado.nota << endl;
    }
}

// Enfileira um valor
// Entrada:
//  v: vetor com elementos da fila
//  fim: fim da fila
//  num: nmero de elementos atuais
//  valor: valor a ser enfileirado
// Retorna:
//  1- Se fila cheia
//  0- Caso contrrio
int enfileirar(Aluno v[], int &fim, int &num, Aluno valor) {
    // Se a fila est cheia... retorna 1
    if (num==MAX) return 1;
    // Se fila no est cheia, vamos enfileirar
    fim = fim + 1;
    if (fim>=MAX) fim = fim - MAX;
    v[fim] = valor;
    num = num + 1;
    // Indica que valor foi enfileirado
    return 0;
}


// Desenfileira um valor
// Entrada:
//  v: vetor com elementos da fila
//  ini: inicio da fila
//  fim: final da fila
//  num: nmero de elementos atuais
//  valor: Local a colocar valor desenfileirado
// Retorna:
//  valor: valor desenfileirado
//  1- Se fila vazia
//  0- Caso contrrio
int desenfileirar(Aluno v[], int &ini, int fim, int &num, Aluno &valor) {
    // Se a fila est vazia... retorna 1
    if (num == 0) return 1;
    // Se fila no est vazia, vamos desenfileirar
    valor = v[ini];
    ini = ini + 1;
    if (ini >= MAX) ini = ini - MAX;
    num = num - 1;
    // Indica que valor foi desenfileirado
    return 0;
}


